<script lang="ts">
  import dedent from "dedent-js"
  import Prism from "svelte-prism"

  import { browser } from "$app/environment"
  import { goto } from "$app/navigation"
  import { page } from "$app/stores"
  import type { Access } from "$lib/access"
  import type {
    Commune,
    CommuneCollectiviteOutreMer,
  } from "$lib/code_officiel_geographique"
  import ErrorAlert from "$lib/components/errors/ErrorAlert.svelte"
  import JsonTree from "$lib/components/JsonTree.svelte"
  import type { DistributionPostale } from "$lib/distributions_postales"
  import type { CommuneSuggestion } from "$lib/suggestions"

  import type { PageData } from "./$types"

  export let data: PageData

  let init = true
  const { url } = $page
  const { searchParams } = url
  const fields = searchParams.getAll("field")
  let communeField = fields.includes("commune")
  let distributionsPostalesField = fields.includes("distributions_postales")
  let q = searchParams.get("q") ?? ""

  $: ({ error, suggestions } = data)

  $: handleChange(q, communeField, distributionsPostalesField)

  $: sourceCode = dedent`
      const response = await fetch(
        ${JSON.stringify(new URL(url.pathname, url.origin))} +
          ${JSON.stringify(
            "?" + searchFromParams(q, communeField, distributionsPostalesField),
          )},
        { headers: { Accept: "application/json" } }
      );
      const { suggestions } = await response.json();
    `

  async function handleChange(
    q: string,
    communeField: boolean,
    distributionsPostalesField: boolean,
  ): Promise<void> {
    if (browser) {
      if (init) {
        init = false
      } else {
        const search = searchFromParams(
          q,
          communeField,
          distributionsPostalesField,
        )
        await goto(`${url.pathname}${search ? "?" + search : ""}`, {
          keepFocus: true,
          noScroll: true,
        })
      }
    }
  }

  function searchFromParams(
    q: string,
    communeField: boolean,
    distributionsPostalesField: boolean,
  ): string {
    return new URLSearchParams(
      [
        ["q", q ?? undefined],
        ["field", communeField ? "commune" : undefined],
        [
          "field",
          distributionsPostalesField ? "distributions_postales" : undefined,
        ],
      ].filter(([, value]) => value !== undefined) as Array<[string, string]>,
    ).toString()
  }

  function summarize(
    access: Access | undefined,
    value: unknown,
  ): string | undefined {
    if (access === undefined) {
      return undefined
    } else if (access.access === undefined) {
      const suggestion = value as CommuneSuggestion
      return suggestion.role === undefined
        ? suggestion.autocompletion
        : `${suggestion.autocompletion} (${suggestion.libelle})`
    } else if (access.key === "commune") {
      const commune = value as Commune & CommuneCollectiviteOutreMer
      return `${commune.LIBELLE} (${commune.COM ?? commune.COM_COMER})`
    } else if (access.access.key === "distributions_postales") {
      const distributionPostale = value as DistributionPostale
      return [
        distributionPostale.ligne_5,
        `${distributionPostale.code_postal} ${distributionPostale.libelle_d_acheminement}`,
      ]
        .filter(Boolean)
        .join(", ")
    } else {
      return undefined
    }
  }
</script>

<header class="prose my-6 max-w-full">
  <h1>Service de suggestion de communes (DGCL)</h1>
</header>

{#if error != null}
  <ErrorAlert {error} />
{/if}

<form class="mx-auto max-w-lg" on:submit|preventDefault>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">Commune</span>
      <input
        class="input-bordered input w-full max-w-xs"
        type="text"
        placeholder="Code postal, commune, lieu-dit ou code Insee"
        bind:value={q}
      />
    </label>
  </div>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">Informations sur la commune</span>
      <input bind:checked={communeField} class="checkbox" type="checkbox" />
    </label>
  </div>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text"
        >Informations sur les distributions postales de la commune</span
      >
      <input
        bind:checked={distributionsPostalesField}
        class="checkbox"
        type="checkbox"
      />
    </label>
  </div>
</form>

<section>
  <header class="prose my-4 max-w-full">
    <h2>Requête</h2>
  </header>

  <div>
    <Prism language="javascript" source={sourceCode} />
  </div>
</section>

{#if error == null}
  <section>
    <header class="prose my-4 max-w-full">
      <h2>Suggestions</h2>
    </header>

    {#if !suggestions?.length}
      <p><i>Aucune suggestion</i></p>
    {:else}
      <div>
        <JsonTree frame={false} open {summarize} value={suggestions} />
      </div>
    {/if}
  </section>
{/if}
